/*
Autor:		Rafael Alberto Moreno Parra
URL:		http://www.geocities.com/krousky
Clase:		Inicializa.
Lenguaje:	C++

Propsito:
Inicializa las variables para la simulacin

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "Inicializa.h"
#include "StringUtil.h"

void Inicializa::vPantallaIni()
{
	printf("Independencia 08: Poblaciones y Competencia\n\n");
	printf("Autor: Rafael Alberto Moreno Parra\n");
	printf("Fecha: 16 de Diciembre de 2002\n");
	printf("E-mail: enginelife@hotmail.com\n");
	printf("http://www.geocities.com/krousky\n\n");
};

//Abre y estudia el archivo de inicializacin
int Inicializa::vLeeArchivoIni()
{
	FILE *fpInicio;
	char sFrase[600], sVariable[200], sValor[200];
    unsigned int iCar;
	StringUtil StrUtil;

	//Inicializa la estructura
	stDatVA.iPoblacion = 0;
	stDatVA.iNumInstMin = 0;
	stDatVA.iNumInstMax = 0;
	stDatVA.iTotalVar = 0;
	stDatVA.iTotalFun = 0;
	strcpy(stDatVA.sArchResult, "Indep01.txt");
	
	fpInicio = fopen("Indep08.ini", "r+t");
	if (fpInicio == NULL)
    {
		printf("Error al tratar de abrir archivo de inicializacin Indep08.ini\n");
		return -1;
    }
	while(!feof(fpInicio))
	{
		fgets(sFrase, 298, fpInicio);
		StrUtil.vQuitaEspacios(sFrase);

		//Extrae variables y valores
		for (iCar=0; iCar<strlen(sFrase) && sFrase[iCar]!='='; iCar++);
		StrUtil.vLeft(sVariable, sFrase, iCar);
		StrUtil.vMid(sValor, sFrase, iCar+2,strlen(sFrase)-1);

		//Clasifica variables
		if(strcmp(sVariable, "iTotalCiclos")==0) stDatVA.iTotalCiclos = atoi(sValor);
		if(strcmp(sVariable, "iTotalJuegos")==0) stDatVA.iTotalJuegos = atoi(sValor);
		if(strcmp(sVariable, "iTotalTurnos")==0) stDatVA.iTotalTurnos = atoi(sValor);
		if(strcmp(sVariable, "iTotalUsarFuncion")==0) stDatVA.iTotalUsarFuncion = atoi(sValor);
		if(strcmp(sVariable, "iPoblacion")==0) stDatVA.iPoblacion = atoi(sValor);
		if(strcmp(sVariable, "iNumInstMin")==0) stDatVA.iNumInstMin = atoi(sValor);
		if(strcmp(sVariable, "iNumInstMax")==0) stDatVA.iNumInstMax = atoi(sValor);
		if(strcmp(sVariable, "iTotalVar")==0) stDatVA.iTotalVar = atoi(sValor);
		if(strcmp(sVariable, "iProbaVar")==0) stDatVA.iProbaVar = atoi(sValor);
		if(strcmp(sVariable, "iTotalFun")==0) stDatVA.iTotalFun = atoi(sValor);
		if(strcmp(sVariable, "iProbabIF")==0) stDatVA.iProbabIF = atoi(sValor);
		if(strcmp(sVariable, "iProbabFN")==0) stDatVA.iProbabFN = atoi(sValor);
		if(strcmp(sVariable, "iTotalCPU")==0) stDatVA.iTotalCPU = atoi(sValor);
		if(strcmp(sVariable, "iAnchoTabl")==0) stDatVA.iAnchoTabl = atoi(sValor);
		if(strcmp(sVariable, "iLargoTabl")==0) stDatVA.iLargoTabl = atoi(sValor);

		if(strcmp(sVariable, "sArchResult")==0)
		{
			if (strlen(sValor) > 15 || strlen(sValor) < 3)
			{
				printf("Mal Nombre de archivo de resultado. sArchResult Mnimo: 3 Mximo: 15 caracteres\n");
				return -1;
			}
			strcpy(stDatVA.sArchResult, sValor);
		}
	}
	

    //Valida los valores de entrada
	if (stDatVA.iNumInstMax > 480 || stDatVA.iNumInstMax < 8)
	{
		printf("Mal nmero de instrucciones (iNumInstMax min 8 max 480)\n");
		return -1;
	}

	if (stDatVA.iTotalVar < 2 )
	{
		printf("Mal nmero de Variables (iTotalVar min 2 max 30)\n");
		return -1;
	}

	fclose(fpInicio);
	return 0;
};

//Hace el encabezado del archivo de resultados
void Inicializa::vArchResult()
{
    //Leidos de una vez los parmetros de simulacin, comienza a simular
	FILE *fpSimular;
    unlink(stDatVA.sArchResult);
	fpSimular = fopen(stDatVA.sArchResult, "a+t");
	fprintf(fpSimular,"Independencia 08: Jugar\n");
	fprintf(fpSimular,"\nPosibilidades:\n");
	fprintf(fpSimular,"Nmero de Instrucciones mnimas para cada Algoritmo: %d\n", stDatVA.iNumInstMin);
	fprintf(fpSimular,"Nmero de Instrucciones mximas para cada Algoritmo: %d\n", stDatVA.iNumInstMax);
	fprintf(fpSimular,"Total variables usadas: %d\n", stDatVA.iTotalVar);
	fprintf(fpSimular,"Probabilidad de usar Variables: %d%%\n", stDatVA.iProbaVar);
	fprintf(fpSimular,"Total funciones del ambiente llamadas: %d\n", stDatVA.iTotalFun);
	fprintf(fpSimular,"Probabilidad de uso de instrucciones IF: %d%%\n", stDatVA.iProbabIF);
	fprintf(fpSimular,"Probabilidad de uso de Funciones: %d%%\n", stDatVA.iProbabFN);
	fprintf(fpSimular,"Probabilidad de uso de instrucciones SET (asignacion): %d%%\n", 100 - (stDatVA.iProbabIF+stDatVA.iProbabFN) );
	
	time_t ltime;
    time( &ltime );
    fprintf(fpSimular,"\nSimulacin inicia en: %s\n", ctime( &ltime ) );
	fclose(fpSimular);
};


//Graba una lnea al archivo
void Inicializa::vGrabaLinea(char *sMensaje)
{
	FILE *fpSimular;

	fpSimular = fopen(stDatVA.sArchResult, "a+t");
	fprintf(fpSimular,"%s", sMensaje);
	fclose(fpSimular);
};

//Graba a archivo el algoritmo gentico
void Inicializa::vGrabaAlgoritmos(unsigned int iIntento, float fMargenError, char *sMensaje)
{
	FILE *fpSimular;

	fpSimular = fopen(stDatVA.sArchResult, "a+t");
	fprintf(fpSimular,"Intento: [%d], Margen de Error (menor es mejor): [%f]\n", iIntento, fMargenError);
	fprintf(fpSimular,"%s\n", sMensaje);
	fclose(fpSimular);
};

//Este es el pie de pgina del archivo de resultado
void Inicializa::vFinalSimulacion()
{
	FILE *fpSimular;
	time_t ltime;

	fpSimular = fopen(stDatVA.sArchResult, "a+t");
	time( &ltime );
	fprintf(fpSimular,"Finaliza en: %s\n", ctime( &ltime ) );
	fclose(fpSimular);
};