/* Clase Organismo

Exones: son las porciones de ADN con un cdigo funcional.
Se ha argumentado que los exones podran ser antiguos "minigenes"
que en un principio codificaban pequeas secuencias funcionales
de aminocidos. Segn esta hiptesis, las protenas modernas
habran surgido por agregacin de varias de estas secuencias
aminocidos.

Intrones: En muchos organismos, una cantidad sorprendentemente grande
del ADN no parece intervenir activamente en la codificacin de
proteinas. Esta proporcin vara segn las especies: por ejemplo del 
9% al 27% en humanos, 75% en nematodos, 67% en moscas de la fruta,
99% en peces pulmonados. Parte de este ADN no codificador esta formado
por intrones.

Esta clase representara un exon o intron porque es en si una
instruccin completa del algoritmo gentico.

En el ADN de cualquier ser vivo se encuentra cuatro(4) tipos de bases
nitrogenadas que forman los nucletidos:
Adenina (A)
Timina (T)
Citosina (C)
Guanina (G)

Cada peldao de la escalera del ADN esta formado por la unin de dos
bases, la pareja es as:
Adenina con Timina
Citosina con Guanina

Los nucletidos A, T, C, G son como las letras de un alfabeto gentico,
con el que se ha elaborado un lenguaje para la informacin gentica.
Este lenguaje esta formado exclusivamente por tres palabras de tres
letras: AAA, CGT, TCC, etc.. Esto es lo que se conoce como cdigo de
tripletes. En ltimo trmino, cada uno de estos tripletes equivale,
en trminos de produccin, a un aminocido concreto. Los aminocidos
son las unidades estructurales de las protenas; las protenas forman
el cuerpo de los organismos, y tambin son protenas las enzimas y
hormonas responsables de su funcionamiento.

Autor:		Rafael Alberto Moreno Parra
URL:		http://www.geocities.com/krousky
Clase:		Organismo
Lenguaje:	C++
Fecha:		16 de Diciembre de 2002

*/

class MasApto {
private:
	struct stTriplete
	{
		bool bEjecuta; /* Se coloca a TRUE si la instruccion es ejecutada */
		unsigned int iInstruccion; /* Cdigo de la Instruccin IF_Mayor, IF_Menor, SET o una funcion */
		unsigned int iVariable; /* Variable para asignarse o para comparacin */
		bool bEsVariable1; /* iOperando1 es una variable o un numero */
		unsigned int iOperando1; /* Variable o numero 1 en la expresin */
		bool bEsVariable2; /* iOperando2 es una variable o un numero */
		unsigned int iOperando2; /* Variable o numero 1 en la expresin */
		unsigned char cOperador; /* + - por dividido */
		unsigned int iGotoLabel; /* Hacia que instruccin ir */
	}; /* 1bit + 4bytes + 4bytes + 1bit + 4bytes + 1bit + 4bytes + 1byte + 4 bytes = 22 bytes */


public:
	struct stTriplete m_oTriplete[200]; //Hasta 200 instrucciones
	unsigned int m_iMaxGenOrg; //Total Numero de Instrucciones
	unsigned int iPuntaje; //Adaptacin ser vivo
};